/*
  Copyright (C) 1999-2004 BITPlan GmbH
  Meerbuscher Str. 58-60
  40670 Meerbusch-Osterath

  Tel. +49-(0)2159/5236-0
  Fax. +49-(0)2159/5236-100

  Bastian Mathes (bm@bitplan.com)
 
	Smartgen Scanner, scans for tokens and colorize them
	
  $Header: /usr/cvsroot/Source/Eclipse/com.bitplan.eclipse.smartgen/src/com/bitplan/eclipse/smartgen/editors/SmartgenScanner.java,v 1.1 2004/09/15 02:00:14 bm Exp $
  $Log: SmartgenScanner.java,v $
  Revision 1.1  2004/09/15 02:00:14  bm
  initial upload of the eclipse plugin


*/

package com.bitplan.eclipse.smartgen.editors;

import org.eclipse.jface.text.TextAttribute;
import org.eclipse.jface.text.rules.EndOfLineRule;
import org.eclipse.jface.text.rules.MultiLineRule;
import org.eclipse.jface.text.rules.SingleLineRule;
import org.eclipse.jface.text.rules.IRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.RuleBasedScanner;
import org.eclipse.jface.text.rules.Token;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Display;

public class SmartgenScanner extends RuleBasedScanner {
	private static Color TAG_COLOR = new Color(Display.getCurrent(), new RGB(200,0,0));
	private static Color COMMENT_COLOR = new Color(Display.getCurrent(), new RGB(0,0,200));
	private static Color JAVACOMMENT_COLOR = new Color(Display.getCurrent(), new RGB(0,100,200));
	private static Color JAVA_COLOR = new Color(Display.getCurrent(), new RGB(0,200,0));
	private static Color DEFAULT_COLOR = new Color(Display.getCurrent(), new RGB(0,0,0));
	
	/**
	 * Syntax Highlighter for smartGENERATOR
	 *
	 */
	public SmartgenScanner() {
		IToken tagToken = new Token(new TextAttribute(TAG_COLOR));
	  IToken commentToken = new Token(new TextAttribute(COMMENT_COLOR));
	  IToken javacommentToken = new Token(new TextAttribute(JAVACOMMENT_COLOR));
		IToken javaToken = new Token(new TextAttribute(JAVA_COLOR));
	  IToken defaultToken = new Token(new TextAttribute(DEFAULT_COLOR));
	  IRule[] rules = new IRule[5];
	  EndOfLineRule tmp = new EndOfLineRule("#.", commentToken);
	  tmp.setColumnConstraint(0);
	  rules[0] = (IRule) tmp;
	  rules[1] = new MultiLineRule("/*","*/",javacommentToken);
	  tmp = new EndOfLineRule(".", javaToken);
	  tmp.setColumnConstraint(0);
	  rules[2] = tmp;
	  rules[3] = new EndOfLineRule("#",tagToken);
	  rules[4] = new SingleLineRule("<",">",tagToken);
	  setDefaultReturnToken(defaultToken);
	  setRules(rules);
	} // SmartgenScanner
}
